/* Copyright 2015 CyberTech Labs Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. */

#pragma once

#include <QtCore/QObject>
#include <QtCore/QVector>

#include "deviceInterface.h"

#include "declSpec.h"

namespace trikControl {

/// Provides characteristics of PWM signal supplied to the port.
class TRIKCONTROL_EXPORT PwmCaptureInterface : public QObject, public DeviceInterface
{
	Q_OBJECT

public slots:
	/// Returns three readings of PWM signal frequency.
	virtual QVector<int> frequency() = 0;

	/// Returns PWM signal duty.
	virtual int duty() = 0;
};

}
