/* Copyright 2015 CyberTech Labs Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. */

#pragma once

#include <QsLog.h>

#include "trikRuntimeException.h"

namespace trikKernel {

/// Exception that is thrown when something is wrong with implementation of trikRuntime.
class InternalErrorException : public TrikRuntimeException
{
public:
	/// Constructor.
	/// @param message - information about what went wrong.
	InternalErrorException(const QString &message)
		: mMessage(message)
	{
		QLOG_ERROR() << "Internal error:" << message;
	}

	/// Returns exception information.
	const QString &message() const
	{
		return mMessage;
	}

private:
	const QString &mMessage;
};

}
